/*
 *
 * This establishes a number of constants used for configuration of hte application
 *
 */

/*
 * Application Configuration Location
 */

//var MAPBOOK_FILE = '/datasets/CONFIGS/SAINT_PAUL/PUBLIC_WORKS/MAPBOOKS/TS/test.xml';
//var MAPBOOK_FILE = '/gis/gambit/html/test.xml';
//var MAPBOOK_FILE = '/gis/gismo-test/html/demo.xml';
var MAPBOOK_FILE = 'demo.xml';

/*
 * Additional Server Tools
 */
var DRAWING_URL = '/gis/mapscript/cgi-bin/saveDrawing.pl?coords=%COORDS%&shape=%SHAPE%&buffer=%BUFFER%&title=%TITLE%';

/*
 * MapServer Location
 */

var MAPSERVER_URL = '/cgi-bin/mapserv.exe';
var MAPSERVER_IMAGE_URL = MAPSERVER_URL+'?map=%MAPFILE%&mapext=%EXTENTS%&mapsize=%SIZE%&mode=map';
var MAPSERVER_DATA_URL = MAPSERVER_URL+'?map=%MAPFILE%&mapext=%EXTENTS%&mapsize=%SIZE%&mode=nquery&searchmap=true';
var MAPSERVER_LEGEND_URL = MAPSERVER_URL+'?map=%MAPFILE%&mapext=%EXTENTS%&mapsize=%SIZE%&mode=legend';

/* 
 * You can have what-ever CGI you want generate a scale bar
 * only two variables are passed to it:
 *	[SIZE] - The image size of hte map
 *	[EXTENTS] - The extents in "MINX MINY MAXX MAXY" format.
 * To disable the Scalebar, simply set SCALEBAR_CALL to null or ''
 */
var SCALEBAR_CALL = '/datasets/ANNOTATION/SAINT_PAUL/PUBLIC_WORKS/GISMO/scalebar.map?mapsize=[SIZE]&mapext=[EXTENTS]&mode=scalebar';

/*
 * This is the client enforced limit on how many objects it will
 * be willing to process once downloaded.  Setting this rediculously high
 * will the control to be in the mapfiles/server.
 */
var LAYER_MAXIMUM_OBJECTS = 200;

/*
 * If there is a failure, Moose will attempt to make the call again
 * this sets the maximum number of attempts
 */
var SERVER_MAXIMUM_ATTEMPTS = 3;

/*
 * Some image Locations.
 */

var BLANK_IMAGE = 'images/blank.gif';
var UNKNOWN_DEFAULT_ICON = 'images/map_info.gif';
var SERVICE_DEFAULT_ICON = 'images/tool.png';
var MAP_DEFAULT_ICON = 'images/map_image_loaded.png';
var VIEW_DEFAULT_ICON = 'images/view.gif';

var FOLDER_ICON = 'images/folder.png';
var FOLDER_OPEN_ICON = 'images/open_folder.png';
var MAP_LOADING_ICON ='images/loading.png';
var MAP_DATA_ICON = 'images/map_data_loaded.png';
var MAP_OVERLOAD_ICON = 'images/map_overload.png';
var MAP_ERROR_ICON = 'images/map_error.png';

var REMOVE_ICON = 'images/remove.png';
var RELOAD_ICON = 'images/reload.png';
var FADE_ICON = 'images/fade.png';
var UNFADE_ICON = 'images/unfade.png';

var CHECKED_ICON = 'images/map_info.gif';
var UP_ICON = 'images/arrow_up.png';
var DOWN_ICON = 'images/arrow_down.png';

var SLIDE_LEFT = 'images/slide_left.png';
var SLIDE_RIGHT = 'images/slide_right.png';

var META_DEFAULT_ICON = 'images/meta.png';
var HELP_DEFAULT_ICON = 'images/help.png';


var DEFAULT_WINDOW_INDEX = 100;

/*
 * Cursor Configuration
 */

var CURSOR_NOTHING = 'default';

var CURSOR_ZOOM_IN = 'crosshair';
var CURSOR_ZOOM_OUT = 'crosshair';
var CURSOR_ZOOM_PAN = 'move';

var CURSOR_POPUPS = 'help';
var CURSOR_DRAW = 'pointer';
